﻿var rMenu={};
var rPidMenu={};
var src_Menu={};
var mux_treeObj={};
var source_treeObj={};
var mode_num=0;
var mode_flag=0;
var new_line;
var edit_line;
var NIT1Nodes;
var NIT2Nodes;
var NITSection;
var nit_add_edit;		//1=add,0=edit
var DEF = {
	SEND_TYPE:{
		GIVE:0,
		GET:1
	},
	MASK:[0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80,0x100],
	STREAM_TYPE:{
		VIDEO_S:0x02,
		AUDIO_S:0x04,
		OTHER_S:0x06,
		ECM_S:0x01,
		EMM_S:0x03,
		PMT_S:0x07,
		MUX_M:0x0a,
		CAS_M:0x0b
	},

	TSIN_STATUS:{
		LOCK:0,
		PSI_READY:1,
		PSI_CHANGE:2,
		SDT_READY:3,
		SDT_CHANGE:4,
		NIT_READY:5,
		NIT_CHANGE:6,
		EIT_READY:7,
		EIT_CHANGE:8
	},
	IPS:{
		IP0:0,
		IP1:1,
		IP2:2,
		IP3:3,
		PORT:4,

		LEN:5
	},
	INPUT_TREE:{
		//dim1
		INDEX:0,
		LOCK:1,
		PAT_CRC:2,
		PROS_NUM:3,
		EMMPIDS_NUM:4,
		IPS_NUM:5,

		LEN:6,

		//dim2 IP_PARAS

		//dim3 PROGRAM_PARAS
		PROS:{
			NAME:0,
			PROVIDER_NAME:1,
			PN:2,
			PMT:3,
			PCR:4,
			FCA_MODE:5,
			SER_TYPE:6,
			ESPIDS_NUM:7,
			ECMPIDS_NUM:8,

			LEN:9,

			//dim4 ES_PIDS
			ESPIDS:{
				PID:0,
				TYPE:1,

				LEN:2
			}
		}
	},
	MUX_TREE:{
		//dim1
		INDEX:0,
		SET_NUM:1,
		PROS_NUM:2,
		PID_PASS_NUM:3,
		NIT_SECTION_NUM:4,

		LEN:5,

		//dim2 programs
		PROS:{
			SOR_INDEX:0,
			OLD_INFOS_NUM:1,
			MUX_INFOS_NUM:2,
			MUX_PIDS_NUM:3,
			CAS_NUM:4,

			LEN:5,
			OLD_INFOS:{
				//dim3 old infos
				PN:0,
				PMT:1,
				PCR:2,
				PRO_INDEX:3,
				// S_TYPE:3,
				// PRO_NAME:4,
				// PROVIDER_NAME:5,

				LEN:4,
			},
			MUX_INFOS:{
				//dim3 mux infos
				PN:0,
				PMT:1,
				PCR:2,
				S_TYPE:3,
				PRO_NAME:4,
				PROVIDER_NAME:5,

				LEN:6,
			},
			MUX_PIDS:{
				//dim4 mux pid
				ORI:0,
				TYPE:1,
				MUX:2,
				CA_ENA:3,

				LEN:4,
			},
			CAS:{
				TYPE:0,
				ITEM_NUM:1,
				LEN:2,

				//CAS_TYPE&INDEX
				ITEM:{
					CLEAR:0,
					BISS1:1,
					BISSE:2,
					SIM:3,
					LEN:4,
					//BISS-1
					ITEM_BISS_1:{
						ENC_SES: 0,
						LEN:1,
					},
					//BISS-E
					ITEM_BISS_E:{
						ENC_SES:0,
						INJ_ID:1,

						LEN:2,
					},
					//Simlcrypt
					ITEM_SIM:{
						ENA:0,
						AC_INDEXA:1,
						ECM_PID:2,

						LEN:3,
					},
				},
			},
		},
		//dim2 set
		SET:{
			ENA:0,
			BITRATE:1,
			AUTO:2,
			SDT:3,
			NIT:4,
			EIT:5,
			TSID:6,
			OID:7,
			IPOUT_NUM:8,

			LEN:9,
			IPOUT:{
				//dim3 ipout set
				PORT_ENA:0,
				UDP_O_RTP:1,
				IPS_NUM:2,

				LEN:3,
			},
		},

		//dim2 pid pass
		PID_PASS:{
			CH:0,
			ORI:1,
			MUX:2,

			LEN:3,
		},
		//dim2 nit
		NIT_SECTION:{
			TYPE:0,
			DATA:1,

			LEN:2
		}
	}
};
var etb;
var add_program_jsonStr = {};

function updateProgramNode(mux_key,prog_key)
{
	var treeObj = $.fn.zTree.getZTreeObj("t_mux");
	var programNode = treeObj.getNodesByParam("prog_key", prog_key, null);
	if(programNode.length != 1)
		return false;

	if(programNode[0].level == 2)
	{
		//update level 2
		var parentNode = programNode[0].getParentNode();
		programNode[0].t ="Source:"+parentNode.t+"-"+GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.prog_num;
		programNode[0].pn = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.prog_num;
		var initNameStr = programNode[0].name.toString().split('<b style="');
		//console.log(initNameStr);
		programNode[0].name = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.prog_name;
		if(initNameStr.length > 1 )
		{
			programNode[0].name +=  '<b style="color:red">[$]</b>';
		}
		treeObj.updateNode(programNode[0]);

		//update level 3
		var lcnNode = treeObj.getNodesByParam("t", "LCN", programNode[0]);
		var serIDNode = treeObj.getNodesByParam("t", "Service ID", programNode[0]);
		var pmtpidNode = treeObj.getNodesByParam("t", "PMT PID", programNode[0]);
		var pcrpidNode = treeObj.getNodesByParam("t", "PCR PID", programNode[0]);

		if(lcnNode && lcnNode[0].level == 3)
		{
			lcnNode[0].name = lcnNode[0].t + ":" + GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.Lcn_val;
			treeObj.updateNode(lcnNode[0]);
		}

		if(serIDNode && serIDNode[0].level == 3)
		{
			serIDNode[0].name = serIDNode[0].t + ":" + GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.prog_num;
			treeObj.updateNode(serIDNode[0]);
		}
		//console.log(GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PMT_pid);
		//console.log(GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PMT_pid&0X1fff);
		if(pmtpidNode && pmtpidNode[0].level == 3)
		{
			pmtpidNode[0].name = pmtpidNode[0].t + ":" + GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PMT_pid;
			treeObj.updateNode(pmtpidNode[0]);
		}

		if(pcrpidNode && pcrpidNode[0].level == 3)
		{
			pcrpidNode[0].name = pcrpidNode[0].t + ":" + GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PCR_pid;
			pcrpidNode[0].pass = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PCR_pass;
			treeObj.updateNode(pcrpidNode[0]);
		}

		for(var i=0;i<GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos.length;i++)
		{
			var location = parseInt(GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[i].type)*2;
			//var type = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[i].type;
			var pidTypeNode = treeObj.getNodesByParam("t", pidsType[location + 1], programNode[0]);
			if(pidTypeNode && pidTypeNode[0].level == 3)
			{
				pidTypeNode[0].name = pidTypeNode[0].t +":"+ GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[i].mux_pid;
				pidTypeNode[0].pass = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[i].pass;
				treeObj.updateNode(pidTypeNode[0]);
			}

		}
		for(var i=0;i<GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num.length;i++)
		{
			var EcmpidNodes = treeObj.getNodesByParam("t", "ECM", programNode[0]);
			//console.log(EcmpidNodes);
			for(var num=0;num<EcmpidNodes.length;num++){
				if(EcmpidNodes[num].level == 3)
				{
					EcmpidNodes[num].name = EcmpidNodes[num].t +":"+ GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num[num].mux_pid;
					EcmpidNodes[num].pass = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num[num].pass;
					treeObj.updateNode(EcmpidNodes[num]);
				}
			}
		}
	}
}
function updateMuxchNode(obj)
{
	//var Data = jQuery.parseJSON(jsonStr);
	var Data = obj;

	var treeObj = $.fn.zTree.getZTreeObj("t_mux");

	var	FilterIndex = Data.MUX_FILTER_INFOS.value.FilterIndex;
	var mxuchNode = treeObj.getNodesByParam("id", "m1"+parseInt(FilterIndex), null);

	if(mxuchNode.length != 1)
		return false;

	if(mxuchNode[0].level == 1)
	{
		var title = "m"+parseInt(FilterIndex+1)+"-"+Data.MUX_FILTER_INFOS.value.SetFilterInfo.chName;
		mxuchNode[0].t = title;
		mxuchNode[0].name = mxuchNode[0].t;
		if(Data.MUX_FILTER_INFOS.value.SetFilterInfo.muxSwitch == 1)
		{
			mxuchNode[0].name += ' <b style="color:Green">['+'?/'+Data.MUX_FILTER_INFOS.value.SetFilterInfo.outBitrate+']</b>';
		}
		else
		{
			mxuchNode[0].name += ' <b style="color:Gray">['+0+'/'+Data.MUX_FILTER_INFOS.value.SetFilterInfo.outBitrate+']</b>';
		}
		treeObj.updateNode(mxuchNode[0]);

		//更新完，为再次进入Edit 做准备。
		var nameAddto ="";
		nameAddto = " ( ";
		nameAddto += mxuchNode[0].t;
		nameAddto += " )";
		$('#nameAddto').html(nameAddto);

		var mux_key = "mux_"+(parseInt(FilterIndex)+1);
		GlobalSpace.MUX_SET_INFOS.value[mux_key].muxSwitch = Data.MUX_FILTER_INFOS.value.SetFilterInfo.muxSwitch;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].removeCA = Data.MUX_FILTER_INFOS.value.SetFilterInfo.removeCA;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].outBitrate = Data.MUX_FILTER_INFOS.value.SetFilterInfo.outBitrate;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].chName = Data.MUX_FILTER_INFOS.value.SetFilterInfo.chName;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].setId = Data.MUX_FILTER_INFOS.value.SetFilterInfo.setId;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].networkId = Data.MUX_FILTER_INFOS.value.SetFilterInfo.networkId;
		
		GlobalSpace.MUX_SET_INFOS.value[mux_key].PATTrans = Data.MUX_FILTER_INFOS.value.SetFilterInfo.PATTrans;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].PMTTrans = Data.MUX_FILTER_INFOS.value.SetFilterInfo.PMTTrans;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].SDTTrans = Data.MUX_FILTER_INFOS.value.SetFilterInfo.SDTTrans;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].CATTrans = Data.MUX_FILTER_INFOS.value.SetFilterInfo.CATTrans;

		GlobalSpace.MUX_SET_INFOS.value[mux_key].catSwitch = Data.MUX_FILTER_INFOS.value.SetFilterInfo.catSwitch;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].patSwitch = Data.MUX_FILTER_INFOS.value.SetFilterInfo.patSwitch;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].pmtSwitch = Data.MUX_FILTER_INFOS.value.SetFilterInfo.pmtSwitch;
		GlobalSpace.MUX_SET_INFOS.value[mux_key].sdtSwitch = Data.MUX_FILTER_INFOS.value.SetFilterInfo.sdtSwitch;
		//console.log(mxuchNode);
		return true;
	}
}

function updatePidMap(obj){
	var Data = obj;
	var mux_key  = "mux_"+(parseInt($('#mux_s_ch').html()));


	GlobalSpace.MUX_SET_INFOS.value[mux_key].MAP_PID.PIDList = Data.MUX_PID_MAP.value.filter;


}


function apply_callback_type_for_alert(type,mybusy,data)
{
	switch(type)
	{
		case GlobalSpace.DEF_MUX_SRC_PARA:
			//alert('Save Mux Source Setting!');
			//mybusy.remove();
			window.location.reload();
			break;
		case GlobalSpace.DEF_MUX_FILTER_PARA:
			//check remove CA
			//updatePassNodes();
			mybusy.remove();
			$('.theme-popover-mask').fadeOut(100);
			$('.theme-popover').slideUp(200);
			break;
		case GlobalSpace.DEF_MUX_TREE_PARA:
			//alert('Save MuxTree!');
			mybusy.remove();
			break;
		case GlobalSpace.DEF_NO_SHOW:
			console.log("apply_callback_Insrc_toMux Success !!");
			mybusy.remove();
			break;
		default :
			console.log("NO TYPE --- 332 line");
			break;
	}
}
function updatePassNodes() {
	$('#mux_s_ch').html(mux_ch);
	var mux_key = "mux_"+parseInt(mux_ch);
	var passVal;
	if(G.MUX_SET_INFOS.value[mux_key].removeCA == 1){
		passVal = 0;
	}else{
		passVal = 1;
	}
}
function ajax_func_handler(data, fn, ajax_para,mybusy)
{
	switch(ajax_para.type)
	{
		case DEF.SEND_TYPE.GIVE:
			fn(ajax_para.form_id,mybusy,data);
			break;
	}
}


//ajax wrapper
function ajaxWrapMybusy(jsonStr, fn , ajax_para)
{
	console.log("jsonStr="+jsonStr);
	$.ajax({
		url:GlobalSpace.dataurl+'?id='+GlobalSpace.page_id,
		dataType: 'json',
		type: 'POST',
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			var obj = jQuery.parseJSON(jsonStr);
			if(obj.MUX_FILTER_INFOS)
				updateMuxchNode(obj);
			else if(obj.MUX_PID_MAP)
				updatePidMap(obj);
			ajax_func_handler(data, fn, ajax_para,mybusy);


		},
		error: function(){
			if(jsonStr.length>0)
				alert('The data is error 1 !');
			else
				alert('The page initialization failed');

			mybusy.remove();
		}
	});
}

/* lxzheng 2016/02/24  */
function muxCheckedLoseEfficacy()
{
	var nodes = mux_treeObj.getNodes();
	if(nodes)
	{
		nodes[0].halfCheck = false;
		mux_treeObj.checkAllNodes(false);
	}
}

//ajax wrapper
function ajaxWrap(jsonStr, fn , ajax_para)
{

	$.ajax({
		url:GlobalSpace.dataurl+'?id='+GlobalSpace.page_id,
		dataType: 'json',
		type: 'POST',
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			if(ajax_para)
			{
				if(ajax_para.form_id == GlobalSpace.DEF_MUX_TREE_PARA)
				{
					muxCheckedLoseEfficacy();
					ajax_func_handler(data, fn, ajax_para,mybusy);
				}

			}else
			{
				mybusy.remove();
			}
		},
		error: function(data){
			if(jsonStr.length>0)
				alert('The data is error 2 !');
			else
				alert('The page initialization failed');

			mybusy.remove();
		}
	});
}

function captureSelect()
{
	window.location.reload();
	/*	var nodes = source_treeObj.getCheckedNodes(true);
	 var tsin_ch_arr=[];
	 if(nodes.length >= 0 && route_id != -1)
	 {
	 for(var i=0;i<nodes.length;i++)
	 {
	 if(parseInt(nodes[i].level) == 1)
	 {
	 tsin_ch_arr.push(nodes[i].dest_func_channel);
	 }
	 }
	 }

	 capture_click(tsin_ch_arr);*/


}

function cancel_change()
{
	//for cancle button
}

function source_toTransceiver_ajaxWrap(jsonStr, fn, ajax_para)
{
	var G=GlobalSpace;
	var url;

	if (G.json_debug == 1)
	{
		url = "transceiver.json";
	}else
	{
		url = "/goform/setroute";
	}
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:url,
		async:true,
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			ajax_func_handler(data, fn, ajax_para,mybusy);
		},
		error: function(data){
			alert('Data are wrong please modify !');
			mybusy.remove();
		}
	});
}

function apply_source(){
	var json_toTransceriver_obj=
		{
			SET_TRANS:
			{
				form_id: 28,
				dest_card:7,
				value: []
			}
		},

		jsonStr_forTran = "",
		ajax_para={},

		count=0,
		G = GlobalSpace,
		src_card=0,
		src_channel=0,
		level0_name=["Module 1","Module 2","Module 3","Module 4","Module 5","Module 6","M/B"],
		strs=[];



	var nodes = source_treeObj.getCheckedNodes(true);
	var nodes_all = source_treeObj.getNodes();

	//json_toTransceriver_obj.SET_TRANS.dest_card = parseInt(G.page_id & 0x0F);

	if(nodes.length >= 0 && route_id != -1)
	{

		if(!confirm('Save Mux Source ?'))
		{
			return 0;
		}
		else
		{
			for(var num=0;num<nodes.length;num++)
			{
				if(parseInt(nodes[num].level) == 1)
				{
					if((nodes[num].pId == 1) || (nodes[num].pId== 2) ||(nodes[num].pId== 3) ||(nodes[num].pId== 4)||(nodes[num].pId== 5)||(nodes[num].pId== 6) || (nodes[num].pId== 7))
					{
						if(nodes[num].pId < 7)
						{
							src_card = nodes[num].pId - 1;
						}else if(nodes[num].pId >= 7)
						{
							src_card = nodes[num].pId;
						}
						src_channel = nodes[num].id.slice(1);
						//json_toTransceriver_obj
						json_toTransceriver_obj.SET_TRANS.value[count] = {};
						json_toTransceriver_obj.SET_TRANS.value[count].dest_channel = parseInt(count) + parseInt(route_id);
						json_toTransceriver_obj.SET_TRANS.value[count].src_card = parseInt(src_card & 0x0FFF);			 	 //Model
						json_toTransceriver_obj.SET_TRANS.value[count].src_channel = parseInt(src_channel & 0x0FFF);		 //2305
						count++;
					}
				}
			}
		//console.log("tiane count="+count);
			// 给主板 路由表 发送源
			if((0<=count) && (count<=256)){
				jsonStr_forTran= $.toJSON(json_toTransceriver_obj);	//用数组来保存 src .11-> 第一块板子 的第一个
				console.log(jsonStr_forTran);
				ajax_para.type = DEF.SEND_TYPE.GIVE;
				ajax_para.form_id = GlobalSpace.DEF_MUX_SRC_PARA;
				source_toTransceiver_ajaxWrap(jsonStr_forTran, apply_callback_type_for_alert, ajax_para);
			}else{
				alert("The number of channels submitted  must be between 0 and 256 !");
			}
		}

	}else
	{
		if((nodes_all[0].isParent == false) && (nodes_all[1].isParent == false) && (nodes_all[2].isParent == false) && (nodes_all[3].isParent == false) && (nodes_all[4].isParent == false) && (nodes_all[5].isParent == false) && (nodes_all[6].isParent == false))
		{
			confirm('No Module !');
		}

		return 0;
	}

}

//自定义过滤器  for treeObj.getNodesByFilter ->  filter
function filter(node)
{
	return ((node.level == 1) && (node.checked== false));
}

function switchIntree(mode_flag,flag){

	var G = GlobalSpace,treeObj;
	if(flag == 1)
	{
		treeObj = source_treeObj;
	}else if(flag == 2)
	{
		treeObj = mux_treeObj;
	}

	if(mode_flag == 1)
	{
		var nodes_hidden = treeObj.getNodesByFilter(filter); // 查找节点集合
		treeObj.hideNodes(nodes_hidden);
		$('#mode_switch').val("Expand Unselected") ;
	}
	else
	{
		var hidden_nodes = treeObj.getNodesByParam("isHidden", true);
		treeObj.showNodes(hidden_nodes);
		$('#mode_switch').val("Hide Unselected") ;
	}

}
function mode_switch(flag){
	mode_num++;

	if(mode_num%2==0)
	{
		mode_flag=2;
	}
	else
	{
		mode_flag=1;
	}

	switchIntree(mode_flag,flag);
}


function check_mux(){
	alert("check");
}

function apply_select_mux(callType){
	var json_obj =
		{
			Edit_Program_Infos:
			{
				"form_id":29,
				"value":{}
			}
		},
		jsonStr = "",
		ajax_para={},
		temp_obj={},
		temp_obj_p={},
		input_ch_item={},
		input_ps_item=[],
		i,
		j,
		k,
		m,
		flag=0,
		q,
		count,
		system = 0,
		name='',
		mux_index,
		errorFlag=0;

//	console.log(GlobalSpace.Edit_Program_Infos);
	if(callType?confirm('Save Mux mapping?'):1)
	{
		var checked_nodes = mux_treeObj.getCheckedNodes(true);
		var children_nodes;
		var mux_key;

		//console.log("======tiane  checked_nodes.length  = "+checked_nodes.length );
		if(checked_nodes.length >= 0)
		{
			system = $.getConvertNum(GlobalSpace.Remux_BasicInfos_Value.ary_sw);
			for (i=1; i < checked_nodes.length; i++)  //checked_nodes.length  = level 0 + level 1
			{
				if(checked_nodes[i].level == 1)
				{
					var lev2Nodes = checked_nodes[i].children;
					if(typeof(lev2Nodes) == "undefined")
						continue;
					for(k=0;k<lev2Nodes.length;k++){
						if(lev2Nodes[k].iconSkin.indexOf("pProNo")>=0){
							errorFlag = 1;
						}
					}

					//index ch1 - ch48
					mux_index=0;
					name='';
					if(checked_nodes[i].name.indexOf("-") > 0)
					{
						var reco_index= checked_nodes[i].name.split("-"); //结合 mux_index
						name = reco_index[0];
					}else
					{
						name = checked_nodes[i].name;
					}

					mux_index= parseInt(name.split("m")[1]);
					mux_key = "mux_"+parseInt(mux_index);
					//console.log(mux_key);
					//if(GlobalSpace.Edit_Program_Infos.value[mux_key])
					{
						json_obj.Edit_Program_Infos.value[mux_key] = GlobalSpace.Edit_Program_Infos.value[mux_key];
					}

				}else
				{
					errorFlag = 1;
				}
			}

			if(errorFlag == 1){
				alert("Apply mux error !");
				return false;
			}

			jsonStr= $.toJSON(json_obj);
			console.log(jsonStr);

			ajax_para.type = DEF.SEND_TYPE.GIVE;
			ajax_para.form_id = GlobalSpace.DEF_MUX_TREE_PARA;
			ajaxWrap(jsonStr,apply_callback_type_for_alert,ajax_para);
			//setTimeout('delayer()', 2000);

		}
	}
}

/*lxzheng 2016/02/23 */
function apply_all_mux()
{
	//1.让所有的 节点 勾选
	var nodes = mux_treeObj.getNodes();
	if(confirm('Apply All Mux mapping?'))
	{
		nodes[0].checked = true;
		nodes[0].halfCheck = false;
		//console.log("======tiane  nodes[0].children.length = "+nodes[0].children.length);
		for(var i=0;i<nodes[0].children.length;i++)
		{
			nodes[0].children[i].checked = true;
			nodes[0].children[i].halfCheck = false;
		}

		apply_select_mux(0);
	}

}

/*lxzheng 2016/02/23 */
function remove_select_mux()
{
	var json_obj =
		{
			Edit_Program_Infos:
			{
				"form_id":29,
				"value":{}
			}
		},
		jsonStr = "",
		ajax_para={};
	var i=0,flag=0,q=0,mux_index=0,name='',mux_key=0;

	var checked_nodes = mux_treeObj.getCheckedNodes(true);

	if(confirm('Remove Select Mux mapping?'))
	{
		if(checked_nodes.length >= 1)
		{
			for(var j=1;j<checked_nodes.length;j++)
			{
				if(typeof(checked_nodes[j].children) != "undefined")
				{
					if(checked_nodes[j].level == 1)
					{
						mux_index=0;
						name='';
						if(checked_nodes[j].name.indexOf("-") > 0)
						{
							var reco_index= checked_nodes[j].name.split("-"); //结合 mux_index
							name = reco_index[0];
						}else
						{
							name = checked_nodes[j].name;
						}
						mux_index= parseInt(name.split("m")[1]);
						mux_key = "mux_"+parseInt(mux_index);
						GlobalSpace.Edit_Program_Infos.value[mux_key] = {};

						json_obj.Edit_Program_Infos.value[mux_key] = {};
					}
					mux_treeObj.removeChildNodes(checked_nodes[j]);
				}
				else
				{
					continue;
				}
			}
		}

		jsonStr= $.toJSON(json_obj);
		console.log(jsonStr);

		ajax_para.type = DEF.SEND_TYPE.GIVE;
		ajax_para.form_id = GlobalSpace.DEF_MUX_TREE_PARA;
		ajaxWrap(jsonStr,apply_callback_type_for_alert,ajax_para);
	}
}
/*
 //remove  all 按钮的回调函数
 function remove_all_mux(){
 var G = GlobalSpace,
 socNodes=[],
 muxNodes=[],
 temp_obj={},
 temp_obj_p={},//program
 temp_obj_i={},//item
 temp_vlaue=[],
 temp_es=[],
 temp_num=0,
 temp_id="",
 temp_pid="",
 temp_name="",
 num_head="",
 i = 0,
 j = 0,
 k = 0,
 h = 0,
 mux_setting={
 treeId:"m",
 view:{
 showTitle: false
 },
 edit: {
 enable: true,
 showRemoveBtn: mux_showRemoveBtn,
 //			showRenameBtn: mux_showRenameBtn,
 showRenameBtn: 0,
 drag:{
 isCopy:false,
 isMove:false,
 prev:true,
 next:true,
 inner:true
 }
 },
 data: {
 key: {
 title:"t"
 },
 simpleData: {enable: true}
 },
 view:{
 nameIsHTML: true,
 addDiyDom: mux_addDiyDom
 },
 callback: {
 beforeDrag: false,
 onDrag:mux_onDrag,
 beforeDrop: mux_beforeDrop,
 onRemove:mux_remove,
 },
 check: {
 enable:true,
 nocheckInherit: true,
 chkboxType: { "Y": "ps", "N": "ps" }
 }
 };

 if(confirm('Remove All Mux mapping?')){
 G.muxNodes =[
 { id:1, pId:0, name:"Mux", open:true},
 ];

 //G.MUX_TREE.value.length = G.mux_ch;

 for(i=0; i<G.mux_ch; i++)
 {
 G.muxNodes[i+1] = {};
 temp_obj_p = G.muxNodes[i+1];
 temp_obj_p.id = "m";
 temp_obj_p.id += G.muxNodes[0].id;
 temp_obj_p.id += i;
 temp_obj_p.pId=G.muxNodes[0].id;
 temp_obj_p.name='m' + (i+1);
 temp_obj_p.iconSkin="pTs";

 if(G.MUX_TREE.value[i])
 {
 G.MUX_TREE.value[i].index = i+1;
 G.MUX_TREE.value[i].validBitrate = 0;
 G.MUX_TREE.value[i].set_infos.length = 0;
 G.MUX_TREE.value[i].mux_infos.length = 0;
 }

 }

 apply_select_mux();

 $.fn.zTree.init($("#t_mux"), mux_setting, G.muxNodes);
 mux_treeObj = $.fn.zTree.getZTreeObj("t_mux");
 mux_treeObj.checkAllNodes(false);

 //reload_mux_setting(parseInt($('#mux_s_ch').html())-1);
 }

 }
 */
function filter_button_apply(Idx,arrayTemp)
{
	var jsonStr = "",
		ajax_para={};
		switch(Idx){
			case 0:
				var json_obj =
					{
						MUX_FILTER_INFOS:
						{
							"form_id":30,
							"value":
							{

							}

						}
					};
				var flag = true;
				flag = 	flag && GlobalSpace.mux_ch_set_alarm.check(false);
				if(!flag){
					alert("Mux Channel setting are error!");
					return 1;
				}
				else{
					//if(confirm('Save Filter Setting?'))
					{
						json_obj.MUX_FILTER_INFOS.value.FilterIndex = parseInt($('#mux_s_ch').html() - 1);
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo = {};
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.muxSwitch = parseInt($('#mux_sw').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.removeCA = $("#remove_ca").is(":checked")?1:0;
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.outBitrate = $('#outbit').val();
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.chName = $('#chname').val();
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.setId = parseInt($('#tsid').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.networkId = parseInt($('#onid').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.PATTrans = parseInt($('#PATTrans').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.PMTTrans = parseInt($('#PMTTrans').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.SDTTrans = parseInt($('#SDTTrans').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.CATTrans = parseInt($('#CATTrans').val());

						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.patSwitch = parseInt($('#pat_sw').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.pmtSwitch = parseInt($('#pmt_sw').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.sdtSwitch = parseInt($('#sdt_sw').val());
						json_obj.MUX_FILTER_INFOS.value.SetFilterInfo.catSwitch = parseInt($('#cat_sw').val());

						jsonStr= $.toJSON(json_obj);
						console.log(jsonStr);
						ajax_para.type = DEF.SEND_TYPE.GIVE;
						ajax_para.form_id = GlobalSpace.DEF_MUX_FILTER_PARA; //24
						ajaxWrapMybusy(jsonStr, apply_callback_type_for_alert, ajax_para);
					}
				}
			break;
		case 1:
			var json_obj =
			{
				"MUX_PID_MAP":{
							"form_id":31,
							"value":{
								"mux_chan":0,
								"filter":[]
						}
					}
			};
			if($("#mux_alarm_list  #mux_ch_alarm_list #PIDid_t").css("display") != "none")
				alert("Mux PID Filter settings are error!");
			else{
				//err_meg.testVal =0,err_meg.ORI_PID=0,err_meg.MAP_PID=0;
				json_obj.MUX_PID_MAP.value.mux_chan=arguments[2]-1;
				json_obj.MUX_PID_MAP.form_id=31;
				json_obj.MUX_PID_MAP.value.filter=arguments[1];

				jsonStr= $.toJSON(json_obj);
				ajax_para.type = DEF.SEND_TYPE.GIVE;
				ajax_para.form_id = GlobalSpace.DEF_MUX_FILTER_PARA; //24
				ajaxWrapMybusy(jsonStr, apply_callback_type_for_alert, ajax_para);
			}
			break;
		default:
			break;
		}
}

/* 点击 小扳手的 回调 函数*/
var mux_chTemp=0;
var etbPIDFilter=0;
function set_filterInfos(mux_ch,flag,pageIdx)
{
	mux_chTemp=(flag==0?mux_ch:mux_chTemp);
	mux_ch=mux_chTemp;
	console.log("mux_ch="+mux_ch);
	console.log("pageIdx="+pageIdx);
	$(".theme-fieldset-topa").each(function(index,ele){
		index==pageIdx?$(ele).addClass("visited"):$(ele).removeClass("visited")
	});
	var G = GlobalSpace,
			nameAddto='';
	$('#mux_s_ch').html(mux_ch);
	var mux_key = "mux_"+parseInt(mux_ch);
	if(G.MUX_SET_INFOS.value[mux_key]){
		nameAddto = " ( m";
		nameAddto += mux_ch;
		if(G.MUX_SET_INFOS.value[mux_key].chName){
			nameAddto += "-";
			nameAddto += G.MUX_SET_INFOS.value[mux_key].chName;
		}
		nameAddto += " )";
		$('#nameAddto').html(nameAddto);
	}
	$("#mux_alarm_list  #mux_ch_alarm_list  li").removeClass("Validform_wrong").css("display","none");
	switch(pageIdx){
		case 0:
			alarmFlag = [0,0];
			$(".theme-fieldset  .theme-popbod.dform  .theme-signin  .MUXSettings").css("display","block");
			$(".theme-fieldset  .theme-popbod.dform  .theme-signin  .editTableDiv").css("display","none");
			
			if(G.MUX_SET_INFOS.value[mux_key]){
				$('#mux_sw').val(G.MUX_SET_INFOS.value[mux_key].muxSwitch);
				//console.log(G.MUX_SET_INFOS.value[mux_key].removeCA);
				G.MUX_SET_INFOS.value[mux_key].removeCA==1?$("#remove_ca").attr("checked",true):$("#remove_ca").attr("checked",false);
				$('#outbit').val(G.MUX_SET_INFOS.value[mux_key].outBitrate);
				$('#chname').val(G.MUX_SET_INFOS.value[mux_key].chName);
				$('#tsid').val(G.MUX_SET_INFOS.value[mux_key].setId);
				$('#onid').val(G.MUX_SET_INFOS.value[mux_key].networkId);
				$('#PATTrans').val(G.MUX_SET_INFOS.value[mux_key].PATTrans);
				$('#PMTTrans').val(G.MUX_SET_INFOS.value[mux_key].PMTTrans);
				$('#SDTTrans').val(G.MUX_SET_INFOS.value[mux_key].SDTTrans);
				$('#CATTrans').val(G.MUX_SET_INFOS.value[mux_key].CATTrans);

				$('#pat_sw').val(G.MUX_SET_INFOS.value[mux_key].patSwitch);
				$('#pmt_sw').val(G.MUX_SET_INFOS.value[mux_key].pmtSwitch);
				$('#sdt_sw').val(G.MUX_SET_INFOS.value[mux_key].sdtSwitch);
				$('#cat_sw').val(G.MUX_SET_INFOS.value[mux_key].catSwitch);
			}else{
		//		console.log("---NO---");
				nameAddto = "";
				nameAddto = " ( m";
				nameAddto += mux_ch;
				nameAddto += " )";
				$('#nameAddto').html(nameAddto);
				$('#mux_sw').val(0);
				$("remove_ca").attr("checked",false);
				$('#outbit').val(0);
				$('#chname').val("");
				$('#tsid').val(0);
				$('#onid').val(0);
				$('#PATTrans').val("");
				$('#PMTTrans').val("");
				$('#SDTTrans').val("");
				$('#CATTrans').val("");
				$('#pat_sw').val(0);
				$('#pmt_sw').val(0);
				$('#sdt_sw').val(0);
				$('#cat_sw').val(0);
			}
			/* lxzheng 2016/02/26 **/
			G.mux_ch_set_alarm.check();
		break;
	case 1:
			$(".theme-fieldset  .theme-popbod.dform  .theme-signin  .MUXSettings").css("display","none");
			$(".theme-fieldset  .theme-popbod.dform  .theme-signin  .editTableDiv").css("display","block");
			mapPIDBtnClick(5);
		
		break;
	default:
		break;
	}
	$('.theme-popover-mask').fadeIn(100);
	$('#theme_popover_muxset').slideDown(200);
}

//=========Tiane=============

var alarmFlag = [0,0] ;

function checkThisVal(this_obj){
	var num=0;
	 var Exg = /^[0-9]*$/; 
	 var Val = $(this_obj).val();
	 var testVal = Exg.test(Val);  //整数
	 var table = document.getElementById("mapPIDTable");
	 var curRow = this_obj.parentNode.parentNode.rowIndex;
	 var curCol = this_obj.parentNode.cellIndex;
	 var alarmFlag2 = 0;
	 
	if($(this_obj).hasClass("Validform_error"))
		alarmFlag2=1;
	else
		alarmFlag2=0;
	 $(this_obj).removeClass("Validform_error");
	 $("#mux_alarm_list  #mux_ch_alarm_list #PIDid_t").css("display","none").html("");
	 console.log("testVal="+testVal);
	 if(testVal==true&&(!(Val>65535))){  	//is number
			 $(this_obj).removeClass("Validform_error");
	}else{     //not num
			$(this_obj).addClass("Validform_error");
			//return true;
	}
	$(".editTable-frozen  #mapPIDTable tbody").children().each(function(index,ele){
		if(index != curRow && $(ele).children().eq(curCol).children().val() == Val){
			$(this_obj).addClass("Validform_error");
		}
	});
	if($(this_obj).hasClass("Validform_error")&&alarmFlag2==1||(!$(this_obj).hasClass("Validform_error")&&alarmFlag2==0)){ //无变化	
	}else{ //有变化
		if(alarmFlag2==1)
			alarmFlag[curCol-1]--;
		else
			alarmFlag[curCol-1]++;
	}
	console.log("alarmFlag[curCol-1]="+alarmFlag[curCol-1]);
	if(alarmFlag[0]>0||alarmFlag[1]>0)
		$("#mux_alarm_list  #mux_ch_alarm_list #PIDid_t").addClass("Validform_wrong").css("display","block").html("ORI_PID or MAP_PID(0x00-0xff) can't be same !");
 }

var curRow = null;
var selected_row = null;
var add_flag = 0;
function selectRow(obj){
	if(curRow){
		  curRow.style.backgroundColor="#FFFFFF";
		  curRow.style.color="#000000";
	  }
	obj.style.backgroundColor="#c1e69d";
	obj.style.color="#FFFFFF";
	curRow=obj;
	selected_row = obj.id;
	console.log("selectRow   selected_row="+selected_row);
}



 function deletePid(){
	 if(selected_row != null){
		 var m=confirm("Would you really like to delete this item?");
		 if(m == true){
			delPid(selected_row);
			return true;
		 }else{
			return false;
		 }
	 }else{
		alert("Please select you want to delete item !")
	 }
 }
 function delPid(){
	 var table = document.getElementById("mapPIDTable");
	 var add_tr_id = document.getElementById(selected_row);
	 var index = add_tr_id.rowIndex;
	 for(var i=0;i<2;i++){
		 var  td = $('#mapPIDTable tr').eq(index).children().eq(i+1).children();
		 if(td.hasClass("Validform_error"))
			 alarmFlag[i]--;
	 }
	// td = $('#mapPIDTable tr').eq(index).children().eq(1).children();
	if(alarmFlag[0]==alarmFlag[1]==0)
		 $("#mux_alarm_list  #mux_ch_alarm_list #PIDid_t").css("display","none").html("");
	console.log("delPid alarmFlag  ="+alarmFlag);
	 console.log("delPid  index="+index);
	 table.deleteRow(index);
	 
 }

 
 function addRow(optionList){
	 var table = document.getElementById("mapPIDTable");
	 console.log(table.rows.length);
	 var trLength = table.rows.length;
	 var newTr = table.insertRow(trLength);
	 var newTd1 = newTr.insertCell(-1);
	 var newTd2 = newTr.insertCell(-1);
	 var newTd3 = newTr.insertCell(-1);
	 newTr.id = trLength ;
	 newTd1.innerHTML="<select name='select' class='input_select'>"+optionList+"</select>";
	 newTd1.style.height="";
	 newTd1.setAttribute("class","editTable-row-cell ");
	 newTd2.innerHTML="&nbsp;&nbsp;<input type='text' name='add_filter_pid' value='' maxlength='4' class='input_txt'  onblur='checkThisVal(this)'>";
	 newTd2.style.height="";
	 newTd2.setAttribute("class","editTable-row-cell ");
	 newTd3.innerHTML="&nbsp;&nbsp;<input type='text' name='add_filter_pid' value='' maxlength='4' class='input_txt' onblur='checkThisVal(this)'>";
	 newTd3.style.height="";
	 newTd3.setAttribute("class","editTable-row-cell ");
	 selectRow(newTr);
	newTr.onclick= function(){
		if(curRow){
			curRow.style.backgroundColor="#FFFFFF";
			curRow.style.color="#000000";
			}
			newTr.style.backgroundColor="#c1e69d";
			newTr.style.color="#FFFFFF";
			curRow = newTr;
			selected_row = newTr.id;
		}
 }
 
 // function selectTr(obj)
// {
	// console.log("22="+$(this).html());
	// $(this).html("&nbsp;&nbsp;<input type='text' name='add_filter_pid' value="+$(this).id+" maxlength='4' class='input_txt' onblur='checkThisVal(this)'>");
// }

function mapPIDBtnClick(Idx){
	var G = GlobalSpace;
	var mux_key = "mux_"+parseInt(mux_chTemp);
	var fromSource=[];
	var PIDList=[];
	if(G.MUX_SET_INFOS.value[mux_key]&&G.MUX_SET_INFOS.value[mux_key].MAP_PID){
		
		fromSource=G.MUX_SET_INFOS.value[mux_key].MAP_PID.fromSource;
		PIDList=G.MUX_SET_INFOS.value[mux_key].MAP_PID.PIDList;
	}
	(fromSource.length==0)?$(".editTable-hd-header .editTable-row-cell  input ").attr("disabled","disabled"):$(".editTable-hd-header .editTable-row-cell  input ").removeAttr("disabled");
	var optionList = "";
	for(var i=0;i<fromSource.length;i++){
		optionList += "<option value="+fromSource[i][0]+">"+fromSource[i][1]+"</option>";
	}
	switch(Idx){
		case 0:	//add
			addRow(optionList);
			break;
		case 1: 	//delete
			deletePid();
			break;
		case 2: 	//apply
			//if($("#mux_alarm_list  #mux_ch_alarm_list #PIDid_t").css("display") != "none")
			//{	
				var array=[];
				$(".editTable-frozen  #mapPIDTable tbody").children().each(function(index,ele){
					var arrayEtr=[];
					$(ele).children().each(function(Idx,eTd){
						if($(eTd).children().length<=0)
						{
							arrayEtr.push(parseInt($(eTd).attr("id")));
							 if(Idx==0)
								 arrayEtr.push( $(eTd).html()); 
						}else{
							arrayEtr.push(parseInt($(eTd).children(":first").val()));
							 if(Idx==0)
								arrayEtr.push( $(eTd).children(":first").find("option:selected").text()); 
						}
					});
					array.push(arrayEtr);
				});

			filter_button_apply(1,array,mux_chTemp);
			break;
		default: //show
				$(".editTableDiv .editTable-frozen #mapPIDTable tbody").empty();
				//console.log("PIDList.length 22="+PIDList.length);
				console.log("PIDList ="+PIDList);
				var str='';
				for(var i=0;i<PIDList.length;i++){
					str +='<tr class=""  onclick="selectRow(this)"  id='+i+' >';
					str +='<td class="editTable-row-cell" style="height: 20px;width:99px;" id='+PIDList[i][0]+'>'+PIDList[i][1]+'</td><td class="editTable-row-cell" style="height: 20px;width:95px;" id='+PIDList[i][2]+'>'+PIDList[i][2]+'</td><td class="editTable-row-cell" id='+PIDList[i][3]+' style="height: 20px;width:55px;padding:1px"><input type="text" name="add_filter_pid" value='+PIDList[i][3]+' maxlength="4" class="input_txt" onblur="checkThisVal(this)"></td>';
					str +='</tr>';
				}
				$(".editTableDiv .editTable-frozen #mapPIDTable tbody").html(str);
			break;
		}
}



function mux_showRemoveBtn(treeId, treeNode){
	return (treeNode.level==2 && treeNode.iconSkin != "emm");
}
function mux_showRenameBtn(treeId, treeNode){
	return (treeNode.level==2 && treeNode.iconSkin == "emm");
}

function setFontCss(treeId, treeNode) {
	return ((typeof treeNode.pass != undefined && treeNode.pass == 0) && (treeNode.level == 3 || treeNode.level == 2)) ? {color:"#999"} : {color:"#333"};
}
/*
 function addHoverDom(treeId, treeNode) {
 if(treeNode.level == 2 && treeNode.iconSkin == "emm"){
 var sObj = $("#" + treeNode.tId + "_span");
 console.log($("#addBtn_"+treeNode.tId));
 if ($("#addBtn_"+treeNode.tId).length>0) {
 var objEvt = $._data($("#addBtn_"+treeNode.tId)[0], "events");
 if (objEvt && objEvt["click"]) {
 console.log("bind click");
 }
 else {
 console.log("Not bind click");
 }

 return;
 }
 var addStr = "<span class='button add' id='addBtn_" + treeNode.tId
 + "' title='pass' onfocus='this.blur();'></span>";
 sObj.after(addStr);

 var btn = $("#addBtn_"+treeNode.tId);
 console.log("2222222222222222222");
 if (btn) btn.bind("click", function(){
 if($(this).hasClass("emmChecked")){
 $(this).removeClass("emmChecked");
 }else{
 $(this).addClass("emmChecked");
 }
 console.log(btn.hasClass("emmChecked"));
 console.log(btn);
 //console.log("click !");
 });
 }
 }

 function removeHoverDom(treeId, treeNode) {
 console.log("111111111111111111");
 $("#addBtn_"+treeNode.tId).unbind().remove();
 }
 */
function beforeEditName(treeId, treeNode) {
	var zTree = $.fn.zTree.getZTreeObj("t_mux");
	zTree.selectNode(treeNode);
	setTimeout(function() {
		setTimeout(function() {
			zTree.editName(treeNode);
		}, 0);
	}, 0);
	return false;
}
function beforeRename(treeId, treeNode, newName, isCancel) {
	if (newName.length == 0) {
		setTimeout(function() {
			var zTree = $.fn.zTree.getZTreeObj("t_mux");
			zTree.cancelEditName();
			alert("Node name cannot be empty.");
		}, 0);
		return false;
	}else if(isNaN(newName) || parseInt(newName) < 32 || parseInt(newName) >= 8191){
		alert("Please fill in the correct values.");
		return false;
	}
	return true;
}
function onRename(e, treeId, treeNode, isCancel) {
	var index = treeNode.getParentNode().name.substr(1);//m7
	var mux_key = "mux_"+parseInt(index);
	var CA_Src_muxKey = treeNode.CASrcMuxKey;
	var editVal = (typeof GlobalSpace.Edit_Program_Infos.value[mux_key] === undefined)?null:GlobalSpace.Edit_Program_Infos.value[mux_key];
	if(editVal != null){
		if(typeof editVal.Emmpids_Num !== undefined && typeof editVal.Emmpids_Num[CA_Src_muxKey] !== undefined ){
			if(parseInt(editVal.Emmpids_Num[CA_Src_muxKey].oriEmm) == parseInt(treeNode.oriEmm)){
				editVal.Emmpids_Num[CA_Src_muxKey].newEmm = parseInt(treeNode.name);
			}
		}
	}
}
/*
 *  功能 :添加 控件 .小扳手
 */
function mux_addDiyDom(treeId, treeNode)
{
	var treeObj = $.fn.zTree.getZTreeObj(treeId);
	var index = treeObj.getNodeIndex(treeNode) + 1;	 //这里 不能替换mux_treeObj,报错
	//_a 这个是 ztree 封装的，<a id="t_mux_2_a">	<span id="t_mux_2_ico">ch 前面的图标</span><span id="t_mux_2_span"> ch </span> </a>
	var aObj = $("#" + treeNode.tId + "_a");
	if ($("#diyBtn_" + treeNode.id).length > 0) {
		console.log("error");
		return;
	}

	if (treeNode.level == 1) {
		//var editStr = "<span class='demoIcon' id='diyBtn_" +treeNode.id+ "' title='"+treeNode.name+"' onfocus='this.blur();'><span class='button DiyDom_setup'></span></span>";
		var editStr = "<span class='demoIcon' id='diyBtn_" + treeNode.id + "'  onfocus='this.blur();'><span class='button DiyDom_setup'></span></span>";
		aObj.append(editStr);

		var btn = $("#diyBtn_" + treeNode.id);
		if (btn.length) {
			btn.bind("click", function () {
				set_filterInfos(index,0,0);
			});
		}
	}if(treeNode.level == 2 && treeNode.iconSkin == "emm"){
	var sObj = $("#" + treeNode.tId + "_span");
	if ($("#addBtn_"+treeNode.tId).length>0)
		return;

	var emmClass; //注意！！！ init
	if(treeNode.pass){
		emmClass = "'button add emmChecked'";
	}else{
		emmClass = "'button add'";
	}
	var addStr = "<span class="+emmClass+" id='addBtn_" + treeNode.tId
		+ "' title='pass' onfocus='this.blur();'></span>";
	sObj.after(addStr);

	var btn = $("#addBtn_"+treeNode.tId);
	if (btn) btn.bind("click", function(){
		$(this).toggleClass("emmChecked");
		var passVal = $(this).hasClass("emmChecked")?1:0;
		var index = treeNode.getParentNode().name.substr(1);//m7
		var mux_key = "mux_"+parseInt(index);
		var CA_Src_muxKey = treeNode.CASrcMuxKey;
		var editVal = (typeof GlobalSpace.Edit_Program_Infos.value[mux_key] === undefined)?null:GlobalSpace.Edit_Program_Infos.value[mux_key];
		if(editVal != null){
			if(typeof editVal.Emmpids_Num !== undefined && typeof editVal.Emmpids_Num[CA_Src_muxKey] !== undefined ){
				editVal.Emmpids_Num[CA_Src_muxKey].pass = parseInt(passVal);
			}
		}
		treeNode.pass = parseInt(passVal);
		treeObj.updateNode(treeNode);
	});
}else
	return;
}

/**lxzheng 2016/01/18 ************************
 *功能:check 之前 检查
 ********************************************** */
function source_beforeCheck(treeId, treeNodes)
{
	return true;
}

/**lxzheng 2016/01/18 ************************
 *功能:check 时候 半选的 状态显示 控制
 ********************************************** */
function source_onCheck(event,treeId, treeNodes)
{
	if(treeNodes.level == 0)
	{
		//init
		treeNodes.nocheck = false;
		treeNodes.halfCheck = false;

		if(treeNodes.checked == true)
		{
			for(var i=0;i<treeNodes.children.length;i++)
			{
				treeNodes.children[i].checked = true;
			}
		}
		else if(treeNodes.checked == false)
		{
			for(var j=0;j<treeNodes.children.length;j++)
			{
				treeNodes.children[j].checked = false;
			}
		}
	}
	else if(treeNodes.level == 1)
	{
		var ParentNode = treeNodes.getParentNode();
		var count = 0;

		//init
		ParentNode.nocheck = false;
		ParentNode.halfCheck = false;

		for(var j=0;j<ParentNode.children.length;j++)
		{
			if(ParentNode.children[j].checked == true)
			{
				count++;
			}
		}

		if(count == 0) //no check
		{
			ParentNode.checked = false;
			ParentNode.halfCheck = false;
		}else if(count < ParentNode.children.length) //halfCheck
		{
			ParentNode.checked = true;
			ParentNode.halfCheck = true;
		}else if(count == ParentNode.children.length) //all check
		{
			ParentNode.checked = true;
			ParentNode.halfCheck = false;
		}
	}

	source_treeObj.updateNode(treeNodes);	//针对 name、target、 url、icon、 iconSkin、checked、nocheck 等这几个用于显示效果的参数进行更新。

	//return true;
}

/**lxzheng 2015/09/06 ************************
 *功能:拖拽之前 检查 是否是 tree 的 第2层.0,1,2.只有 2层 才允许拖拽.
 ********************************************** */
function source_beforeDrag(treeId, treeNodes) {
	for (var i=0,l=treeNodes.length; i<l; i++) {
		if (treeNodes[i].level != 2 || (treeNodes[i].level == 2 && (treeNodes[i].iconSkin.indexOf("emm") != -1) )) {
			return false;
		}
	}

	var str1 = treeNodes[0].getParentNode().getParentNode().name.split('[');
	var str2 = treeNodes[0].getParentNode().name.split('<');
	GlobalSpace.Src_name = str1[0] +'#'+ str2[0];
	GlobalSpace.tree_nodes = treeNodes;
	GlobalSpace.dest_func_channel = treeNodes[0].getParentNode().dest_func_channel;
//	console.log(GlobalSpace.dest_func_channel);
	return true;
}
function source_onDrag(event, treeId, treeNodes) {
	return false;
}
/* lxzheng /09/06
 * treeNodes :被拖拽 节点 的 数据
 * targetNode :被拖拽 放开 的节点的数据
 */
function source_beforeDrop(treeId, treeNodes, targetNode, moveType) {
	var index = 0,
		pn = 0,
		i = 0,
		j = 0,
		temp = 0,
		nodes = {},
		n_obj = {};
	/**lxzheng 09/06 只有 这3种情况满足 */
	if((targetNode.level != 2 && moveType === "prev")||
		(targetNode.level != 2 && moveType === "next")||
		(targetNode.level != 1 && moveType === "inner")){
		return false;
	}

	if(targetNode.level == 1 && moveType === "inner"){

		if(targetNode.children)
			nodes = targetNode.children;

		for(i=0; i<treeNodes.length; i++)
		{
			pn = treeNodes[i].pn;
			index = treeNodes[i].index;
			if(nodes.length){
				for(j=0; j<nodes.length; j++){
					if(pn == nodes[j].pn && index == nodes[j].index){
						alert("Mux Channel has same program Ch=" + nodes[j].index + " PN="+nodes[j].pn);
						return false;
					}
				}
			}
		}

	}else if((targetNode.level == 2 && moveType === "prev")||
		(targetNode.level == 2 && moveType === "next")){
		nodes = targetNode.getParentNode().children;

		for(i=0; i<treeNodes.length; i++)
		{
			pn = treeNodes[i].pn;
			index = treeNodes[i].index;

			if(nodes.length){
				for(j=0; j<nodes.length; j++){
					if(pn == nodes[j].pn && index == nodes[j].index){
						alert("Mux Channel has same program Ch=" + nodes[j].index + " PN="+nodes[j].pn);
						return false;
					}
				}
			}
		}
	}

	return true;
}

function source_onDrop(event, treeId, treeNodes, targetNode, moveType, isCopy)
{
	var	G = GlobalSpace,
		mux_index = 0,
		mux_ch=0,
		i=0,
		j=0,
		flag=0,
		length,
		input_ch_item=[];
	input_ps_item=[];
	input_p_item=[];
	arr={},
		json_arr=[],
		s_index=0,
		s_ch=0,
		mux_pids=[],
		Ecmpids_Num=[],
		src_num=[];

	if((targetNode.level != 2 && moveType === "prev")||
		(targetNode.level != 2 && moveType === "next")||
		(targetNode.level != 1 && moveType === "inner"))
	{
		return false;
	}

	if(targetNode.level == 1 && moveType === "inner"){
		mux_index = mux_treeObj.getNodeIndex(targetNode);
	}else if((targetNode.level == 2 && moveType === "prev")||
		(targetNode.level == 2 && moveType === "next")){
		mux_index = mux_treeObj.getNodeIndex(targetNode.getParentNode());
	}

	mux_ch = mux_index+1; // mux_index: ch1 层 的 路数
	var mux_key = "mux_"+mux_ch;
	if(!G.Edit_Program_Infos.value[mux_key])
	{
		G.Edit_Program_Infos.value[mux_key] = {};
	}
	var system = $.getConvertNum(GlobalSpace.Remux_BasicInfos_Value.ary_sw);
	var passVal = 1;
	/*	if(G.MUX_SET_INFOS.value[mux_key].removeCA == 1){
	 passVal = 0;
	 }else{
	 passVal = 1;
	 }*/

	//treeNodes.length : 拖拽的 节点 个数
	/*	console.log(treeNodes);
	// console.log(targetNode);
	// console.log("treeNodes:"+treeNodes.length+"/ system:"+system);*/
	 //console.log("treeNodes.length="+treeNodes.length);
	for(i=0; i<treeNodes.length; i++)
	{
	//	console.log(treeNodes[i]);
		arr = {};
		G.max_prog_key++;
		arr[G.max_prog_key] = {};
		s_index = treeNodes[i].id;
		old_infos_pn = treeNodes[i].pn;
		src_num = s_index.split("p");	//p0p2304 -> ,0,2304

		/*--2017/01/17 lxzheng  for treeNode pass --*/
		var nodeChilds = treeNodes[i].children;
		//console.log("nodeChilds="+nodeChilds);
		for(var passNum=0;passNum<nodeChilds.length;passNum++){
		//	console.log("nodeChilds[passNum].t ="+nodeChilds[passNum].t);
			if(nodeChilds[passNum].level == 2 && nodeChilds[passNum].t != "Original Service ID" && nodeChilds[passNum].t != "PMT PID" && nodeChilds[passNum].t != "Original Name" && nodeChilds[passNum].t != "Source"){
				nodeChilds[passNum].pass = passVal;
			}
		}

		for(var t=0;t<GlobalSpace.INPUT_TREE_value.length;t++)
		{
			if(GlobalSpace.INPUT_TREE_value[t].src_num == parseInt(src_num[2]))
			{
				input_ch_item = GlobalSpace.INPUT_TREE_value[t];
				input_ps_item =	input_ch_item.In_Pro_infos;
			}
		}

		//input_ch_item 输入 源 节目的 总共列表
		//input_p_item 具体 哪个 节目信息

		input_p_item = input_ps_item[parseInt(src_num[1])];

		//map() 数组 的map() 方法:: 将调用数组的每个元素 传递 给指定的 函数 并返回一个新的数组,不该变 原来的 数组.
		mux_pids = input_p_item.Espids_Num.map(function (val)
		{
			val.pid = val.pid;
			val.mux_pid = val.pid;
			val.type = val.type;
			val.pass = passVal;
			return val;
		});

		arr[G.max_prog_key].dest_func_channel = parseInt(GlobalSpace.dest_func_channel);
		arr[G.max_prog_key].Trans_channel = parseInt(src_num[2]);

		arr[G.max_prog_key].Original_prog_infos = {};
		arr[G.max_prog_key].Original_prog_infos.prog_num = input_p_item.Pro_Num;
		arr[G.max_prog_key].Original_prog_infos.PMT_pid = input_p_item.Pmt_pid;
		arr[G.max_prog_key].Original_prog_infos.PCR_pid = input_p_item.Pcr_pid;
		arr[G.max_prog_key].Original_prog_infos.prog_name = input_p_item.Ser_Name;
		arr[G.max_prog_key].Original_prog_infos.Src_name = GlobalSpace.Src_name;

		arr[G.max_prog_key].Mux_prog_infos = {};
		arr[G.max_prog_key].Mux_prog_infos.prog_num = arr[G.max_prog_key].Original_prog_infos.prog_num;
		arr[G.max_prog_key].Mux_prog_infos.PMT_pid = arr[G.max_prog_key].Original_prog_infos.PMT_pid;
		arr[G.max_prog_key].Mux_prog_infos.PCR_pid = arr[G.max_prog_key].Original_prog_infos.PCR_pid;
		arr[G.max_prog_key].Mux_prog_infos.PCR_pass = passVal;
		//console.log((arr[G.max_prog_key].Original_prog_infos.prog_name)=='');
		//console.log("arr[G.max_prog_key].Original_prog_infos.prog_name="+arr[G.max_prog_key].Original_prog_infos.prog_name);
		if(arr[G.max_prog_key].Original_prog_infos.prog_name=='')
			arr[G.max_prog_key].Mux_prog_infos.prog_name = (arr[G.max_prog_key].Original_prog_infos.prog_num).toString();
		else
			arr[G.max_prog_key].Mux_prog_infos.prog_name = arr[G.max_prog_key].Original_prog_infos.prog_name;
		arr[G.max_prog_key].Mux_prog_infos.provider_name = input_p_item.Ser_Pro_Name;
		arr[G.max_prog_key].Mux_prog_infos.S_TYPE = input_p_item.Program_Type;
		arr[G.max_prog_key].Mux_prog_infos.C_TYPE = input_p_item.C_Type;
		arr[G.max_prog_key].Mux_prog_infos.LcnSwich = 0;
		arr[G.max_prog_key].Mux_prog_infos.Lcn_val = 0;
		//	console.log(input_p_item.C_Type);
		arr[G.max_prog_key].Mux_prog_infos.PMT_version = 1;
		arr[G.max_prog_key].Mux_prog_infos.Fca_Mode = input_p_item.Fca_Mode;

		arr[G.max_prog_key].Mux_pid_infos = mux_pids;

		arr[G.max_prog_key].Ecmpids_Num = [];
		for(var count=0;count<input_p_item.Ecmpids_Num.length;count++){
			arr[G.max_prog_key].Ecmpids_Num[count] = {};
			arr[G.max_prog_key].Ecmpids_Num[count].pid = input_p_item.Ecmpids_Num[count];
			arr[G.max_prog_key].Ecmpids_Num[count].mux_pid = input_p_item.Ecmpids_Num[count];
			arr[G.max_prog_key].Ecmpids_Num[count].pass = passVal;
		}

		treeNodes[i].dest_func_channel = parseInt(GlobalSpace.dest_func_channel);
		treeNodes[i].prog_key = G.max_prog_key;
		//	console.log(treeNodes[i].prog_key);

		/* lxzheng 2016/03/25 for Src_name & New Name*/
			//tiane
		var SNode1 = {nocheck:true,name:'Original Service ID:' +arr[G.max_prog_key].Original_prog_infos.prog_num,iconSkin:"adddata",t:"Original Service ID"};
		SNode1 = mux_treeObj.addNodes(treeNodes[i],-1,SNode1,true);
		var addNodeName1 ='Original Name:' + arr[G.max_prog_key].Original_prog_infos.prog_name;
		var addNode_t1 = addNodeName1;
		if(arr[G.max_prog_key].Fca_Mode)
		{
			addNodeName1 += ' <b style="color:red">[$]</b>';
		}
		var newNode1 = {nocheck:true,name:addNodeName1,iconSkin:"adddata",t:"Original Name"};
		newNode1 = mux_treeObj.addNodes(treeNodes[i],-1,newNode1,true);

		var newNode2 = {nocheck:true,name:'Source:' + GlobalSpace.Src_name,iconSkin:"adddata",t:"Source"};
		newNode2 = mux_treeObj.addNodes(treeNodes[i],-1,newNode2,true);

		var lcnNode = {nocheck:true,name:'LCN:' + arr[G.max_prog_key].Mux_prog_infos.Lcn_val,iconSkin:"adddata",t:"LCN"};
		lcnNode = mux_treeObj.addNodes(treeNodes[i],1,lcnNode,true);
	

		$.extend(G.Edit_Program_Infos.value[mux_key], arr);
		//console.log(G.Edit_Program_Infos);

		/*---------EMM ------------------------*/
		if(typeof(G.Edit_Program_Infos.value[mux_key].Emmpids_Num) != "object"){
			G.Edit_Program_Infos.value[mux_key].Emmpids_Num={};
		}
		var Emmpids_Num = G.Edit_Program_Infos.value[mux_key].Emmpids_Num;

		if(typeof(input_p_item.CA_System_ID) != "undefined" && input_p_item.CA_System_ID.length > 0)
		{
			//console.log(input_ch_item.Emmpids_Num);
			for(var k=0;k<input_p_item.CA_System_ID.length;k++)
			{
				var CA_inKey = input_p_item.CA_System_ID[k].toString();
				var destCh = treeNodes[i].dest_func_channel.toString();
				var CA_Src_muxKey = CA_inKey+"_"+destCh;
				//console.log("CA_SrcKey:"+CA_Src_muxKey+"/CA_System_ID["+k+"]:"+input_p_item.CA_System_ID[k]);
				var emmNode = {nocheck:true,iconSkin:"emm",t:"EMM"};
				var emmSrcNameNode = {nocheck:true,iconSkin:"adddata",t:"src name",name:"Source:"};
				var emmOriNode = {nocheck:true,iconSkin:"adddata",t:"original Emm",name:"Original Emm:"};
				flag = 0;
				var EmmItem = input_ch_item.Emmpids_Num[CA_inKey];
				if(EmmItem){
					if (isDefined(Emmpids_Num[CA_Src_muxKey])) {
						if(isDefined(Emmpids_Num[CA_Src_muxKey].newEmm) && (EmmItem == Emmpids_Num[CA_Src_muxKey].newEmm)){
							flag = 1;
						}
					}
					else{
						Emmpids_Num[CA_Src_muxKey] = {};
						Emmpids_Num[CA_Src_muxKey]["newEmm"] = EmmItem;
						flag = 1;
					}
					//console.log(flag);
					if(flag == 1){
						Emmpids_Num[CA_Src_muxKey].oriEmm = Emmpids_Num[CA_Src_muxKey].newEmm ;
						Emmpids_Num[CA_Src_muxKey].Src_name = GlobalSpace.Src_name;
						Emmpids_Num[CA_Src_muxKey].pass = passVal;
						if(!isDefined(Emmpids_Num[CA_Src_muxKey].pnArr)){
							Emmpids_Num[CA_Src_muxKey].pnArr = [];
						}
						if(Emmpids_Num[CA_Src_muxKey].pnArr.indexOf(old_infos_pn) < 0){
							Emmpids_Num[CA_Src_muxKey].pnArr.push(old_infos_pn);
						}

						emmOriNode.name += Emmpids_Num[CA_Src_muxKey].oriEmm;
						emmSrcNameNode.name += Emmpids_Num[CA_Src_muxKey].Src_name;
						if(Emmpids_Num[CA_Src_muxKey].pnArr.length <= 1) {
							emmNode.name = $.decimalConvert(EmmItem, system);
							emmNode.pass = passVal;
							emmNode.CASrcMuxKey = CA_Src_muxKey;
							emmNode.oriEmm = emmNode.name;
							mux_treeObj.addNodes(emmNode,-1,emmOriNode,true);
							mux_treeObj.addNodes(emmNode,-1,emmSrcNameNode,true);
							mux_treeObj.addNodes(targetNode, -1,emmNode, true);//注意节点顺序
						}
					}
				}
			}
		}

		//	console.log(G.Edit_Program_Infos.value[mux_key].Mux_prog_infos);
		/*--------End---EMM ------------------------*/

		updateProgramNode(mux_key,G.max_prog_key); //for PID pass
	}

	/**** lxzheng 2016/02/24 打钩 父节点 并 update *****/
	if(typeof(targetNode.checked) != "undefined")
	{
		if(targetNode.checked == false)
		{
			targetNode.checked = true;
			mux_treeObj.updateNode(targetNode);
		}
	}

	var Level0_ParentNode = $.updateLevel0Node(targetNode); //function
	if(Level0_ParentNode)
	{
		mux_treeObj.updateNode(Level0_ParentNode);
	}


	/**** End lxzheng 2016/02/24 打钩 父节点 并 update *****/
}

//==========================================
function mux_beforeCheck(treeId, treeNodes)
{

	return true;
}

function mux_onCheck(event,treeId, treeNodes)
{


	if(treeNodes.level == 0)
	{
		//init
		treeNodes.nocheck = false;
		treeNodes.halfCheck = false;

		if(treeNodes.checked == true)
		{
			for(var i=0;i<treeNodes.children.length;i++)
			{
				treeNodes.children[i].checked = true;
			}
		}
		else if(treeNodes.checked == false)
		{
			for(var j=0;j<treeNodes.children.length;j++)
			{
				treeNodes.children[j].checked = false;
			}
		}
	}
	else if(treeNodes.level == 1)
	{
		var ParentNode = treeNodes.getParentNode();
		var count = 0;

		//init
		ParentNode.nocheck = false;
		ParentNode.halfCheck = false;

		for(var j=0;j<ParentNode.children.length;j++)
		{
			if(ParentNode.children[j].checked == true)
			{
				count++;
			}
		}

		if(count == 0) //no check
		{
			ParentNode.checked = false;
			ParentNode.halfCheck = false;
		}else if(count < ParentNode.children.length) //halfCheck
		{
			ParentNode.checked = true;
			ParentNode.halfCheck = true;
		}else if(count == ParentNode.children.length) //all check
		{
			ParentNode.checked = true;
			ParentNode.halfCheck = false;
		}
	}

	mux_treeObj.updateNode(treeNodes);	//针对 name、target、 url、icon、 iconSkin、checked、nocheck 等这几个用于显示效果的参数进行更新。
}
//==========================================
function mux_onDrag(event, treeId, treeNodes) {

	return true;
}

function mux_beforeDrop(treeId, treeNodes, targetNode, moveType)
{
	return false;
}




/*function isEmptyObject(e) {
 var t;
 for (t in e)
 return !1;
 return !0
 }*/
//删除节点 时候的 回调函数
function mux_remove(event, treeId, treeNode)
{
	var	mux_index = parseInt(mux_treeObj.getNodeIndex(treeNode.getParentNode()));
	var mux_key = "mux_"+parseInt(mux_index+1);
	var prog_key = treeNode.prog_key;

	delete GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key];
	/*---------EMM--------------------------*/
	//var src_num=treeNode.id.split("p");	//p0p2304 -> ,0,2304
	//var srcIn = src_num[2].toString();
	var destCh = treeNode.dest_func_channel.toString();
	var pn = treeNode.pn;
	var treeObj = $.fn.zTree.getZTreeObj("t_mux");
	var CA_SrcKey;
	var EmmpidsNumObj;
	/*
	// console.log(treeNode.caSysID);
	 //console.log(GlobalSpace.Edit_Program_Infos.value[mux_key].Emmpids_Num);
	 */

	for(var i=0;i<treeNode.caSysID.length;i++)
	{
		CA_SrcKey = treeNode.caSysID[i].toString()+"_"+destCh;

		if(!isDefined(GlobalSpace.Edit_Program_Infos.value[mux_key].Emmpids_Num[CA_SrcKey]))
			continue;

		EmmpidsNumObj = GlobalSpace.Edit_Program_Infos.value[mux_key].Emmpids_Num;
		EmmpidsNumObj[CA_SrcKey].pnArr.remove(pn);
		if(EmmpidsNumObj[CA_SrcKey].pnArr.length <= 0){
			var mxuchNodes = treeObj.getNodesByParam("CASrcMuxKey",CA_SrcKey, null);
			for(var k=0;k<mxuchNodes.length;k++)
			{
				treeObj.removeNode(mxuchNodes[k],false);
			}
			delete EmmpidsNumObj[CA_SrcKey];
		}
	}
	//console.log(GlobalSpace.Edit_Program_Infos.value[mux_key].Emmpids_Num);
	/*----------End-------------------------*/


	/**** lxzheng 2016/02/24 打钩 父节点 并 update *****/
	Level1_ParentNode = treeNode.getParentNode();
	if(typeof(Level1_ParentNode.checked) != "undefined")
	{
		if(Level1_ParentNode.checked == false)
		{
			Level1_ParentNode.checked = true;
			mux_treeObj.updateNode(Level1_ParentNode);
		}
	}

	var Level0_ParentNode = $.updateLevel0Node(Level1_ParentNode);
	if(Level0_ParentNode)
	{
		mux_treeObj.updateNode(Level0_ParentNode);
	}

	/* *** End lxzheng 2016/02/24 打钩 父节点 并 update **** */
}

/* 右键 */
function showRMenu(event,rMenuid,rMenuobj)
{
	$("#"+rMenuid+" ul").show();
	rMenuobj.css({"top":(event.pageY+15)+"px", "left":event.pageX+"px", "visibility":"visible"});
	$("body").bind("mousedown", onBodyMouseDown);
}

function hideRMenu(rMenuid,rMenuobj) {
	if (rMenuobj) rMenuobj.css({"visibility": "hidden"});
	$("body").bind("mousedown", onBodyMouseDown);
}

function onBodyMouseDown(event){
	var rMenuid_Arr={"capture":"src_Menu","edit_program":"rMenu","pid_filter":"rPidMenu"};
	var rMenuidStr;

	rMenuidStr = rMenuid_Arr[event.target.id];
	if(!(event.target.id && event.target.id == rMenuidStr || (rMenuidStr && $(event.target).parents("#"+rMenuidStr).length>0)  ) )
	{
		rMenu.css({"visibility" : "hidden"});
		src_Menu.css({"visibility" : "hidden"});
		rPidMenu.css({"visibility" : "hidden"});
	}
}

/*function source_OnRightClick(event, treeId, treeNode)
 {
 $("#capture").unbind();

 if(treeNode && treeNode.level == 1 && event.target.tagName.toLowerCase() != "li"  && !treeNode.noR)
 {
 source_treeObj.selectNode(treeNode);
 showRMenu(event,"src_Menu",src_Menu);
 }else if((!treeNode && $(event.target).parents("a").length == 0) && (event.target.tagName.toLowerCase() == "li" || event.target.tagName.toLowerCase() == "ul"))
 {
 source_treeObj.cancelSelectedNode();
 hideRMenu("src_Menu",src_Menu);
 }

 var tsin_ch_arr=[];
 tsin_ch_arr.push(treeNode.dest_func_channel);

 $("#capture").bind("click", function(){capture_click(tsin_ch_arr);});

 }*/
function source_OnRightClick(event, treeId, treeNode)
{
	$("#capture").unbind();
	if(treeNode && treeNode.level == 0 && event.target.tagName.toLowerCase() == "span" && event.target.parentNode.tagName.toLowerCase() == "a" && !treeNode.noR) {
		showRMenu(event,"src_Menu",src_Menu);
		var tsin_ch_arr=[];
		for(var i=0;i<treeNode.children.length;i++){
			tsin_ch_arr.push((treeNode.children[i].dest_func_channel != undefined)?treeNode.children[i].dest_func_channel:-1);
		}
	}

	$("#capture").bind("click", function(){
		hideRMenu("src_Menu",src_Menu);
		capture_click(tsin_ch_arr);
	});
}
function onTimerCaptureSuccess() {
	//console.log(data);
	//window.location.reload();
}
function onTimerCaptureError() {
	alert("Capture error !!");
}
function capture_click(tsin_ch_arr)
{
	//console.log(tsin_ch_arr);
	var json_obj =
		{
			captureInfos:
			{
				"form_id":38,
				"value":[]
			}
		},
		jsonStr = "",
		ajax_para={};

	for(var i=0;i<tsin_ch_arr.length;i++)
	{
		json_obj.captureInfos.value[i] = {};
		json_obj.captureInfos.value[i].tsin_ch = tsin_ch_arr[i];
		json_obj.captureInfos.value[i].setparam = 1;
	}

	jsonStr= $.toJSON(json_obj);
	console.log(jsonStr);

	ajax_para.url = GlobalSpace.dataurl;

	$.ajax({
		dataType: "json",
		type: 'POST',
		url:ajax_para.url,
		async:true,
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			console.log("recive !!");
			onTimerCaptureSuccess(data);
			mybusy.remove();
		},
		error: function(data){
			onTimerCaptureError();
			mybusy.remove();
		}
	});

	//$.pbi_ajaxWrap_mainmux(jsonStr, ajax_para,onTimerCaptureSuccess,onTimerCaptureError);
}

function mux_OnRightClick(event, treeId, treeNode)
{
	if(treeNode.level == 1){
		/*		$("#pid_filter").unbind();
		 if(treeNode && treeNode.level == 1 && event.target.tagName.toLowerCase() != "li"  && !treeNode.noR)
		 {
		 mux_treeObj.selectNode(treeNode);
		 showRMenu(event,"rPidMenu",rPidMenu);
		 }else if((!treeNode && $(event.target).parents("a").length == 0) && (event.target.tagName.toLowerCase() == "li" || event.target.tagName.toLowerCase() == "ul"))
		 {
		 mux_treeObj.cancelSelectedNode();
		 hideRMenu("rPidMenu",rPidMenu);
		 }
		 $("#pid_filter").bind("click", function(){alert("pid filter!");});*/
	}else if(treeNode.level == 2)
	{
		$("#edit_program").unbind();
		//treeNode.noR 属性为true表示禁止右键菜单
		//event.target.tagName eg: SPAN .event.target.tagName.toLowerCase() eg:span
		if(treeNode && treeNode.level == 2 && event.target.tagName.toLowerCase() != "li"  && !treeNode.noR && (typeof(treeNode.children) != "undefined"))
		{
			mux_treeObj.selectNode(treeNode);
			showRMenu(event,"rMenu",rMenu);
		}else if(((!treeNode && $(event.target).parents("a").length == 0) && (event.target.tagName.toLowerCase() == "li" || event.target.tagName.toLowerCase() == "ul") )|| (typeof(treeNode.children) == "undefined"))
		{
			mux_treeObj.cancelSelectedNode();
			hideRMenu("rMenu",rMenu);
		}

		var mux_index = parseInt($.fn.zTree.getZTreeObj("t_mux").getNodeIndex(treeNode.getParentNode())+1);
		$("#edit_program").bind("click", function(){edit_program_click(mux_index,treeNode.prog_key);});	 //都是 从 1 开始的
	}
}

//提交时 选择 了提交 结合append
function edit_program_ok_click()
{
	var mux_index = $("#edit_mux_ch").html();
	var prog_key = $("#edit_prog_key").html();

	var mux_key = "mux_"+parseInt(mux_index);
//console.log(GlobalSpace.Edit_Program_Infos);

	if(GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key])
	{
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.prog_num = parseInt($("#service_id").val());
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PMT_pid = parseInt($("#pmt_pid").val());
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PCR_pid = parseInt(etb.getCellData(0, 2));
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PCR_pass = Number(etb.getCellData(0, 3));
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.prog_name = $("#service_name").val();
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.provider_name = $("#service_provider_name").val();
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.S_TYPE = parseInt($("#service_type").val());
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.C_TYPE = parseInt($("#charset_type").val());
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.PMT_version = parseInt($("#pmt_version").val());
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.LcnSwich =  $("#LcnSwich").val();
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_prog_infos.Lcn_val =  $("#Lcn_val").val();

		var muxCount=0;
		var emmCount = 0;
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos = [];
		GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num = [];
		for(var i=1;i<parseInt(etb.rows.length);i++) //第一行为 PCR
		{
			if(etb.getCellData(i, 0).indexOf("ECM") != -1){
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num[emmCount]={};
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num[emmCount].pid = parseInt(etb.getCellData(i, 1));
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num[emmCount].mux_pid = parseInt(etb.getCellData(i, 2));
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Ecmpids_Num[emmCount].pass = Number(etb.getCellData(i, 3));
				emmCount++;
			}else{
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[muxCount]={};
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[muxCount].type = pidsType[parseInt(pidsType.indexOf(etb.getCellData(i, 0))) - 1 ];
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[muxCount].pid = parseInt(etb.getCellData(i, 1));
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[muxCount].mux_pid = parseInt(etb.getCellData(i, 2));
				GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key].Mux_pid_infos[muxCount].pass = Number(etb.getCellData(i, 3));
				muxCount++;
			}
		}
	}
	//console.log(GlobalSpace.Edit_Program_Infos.value);

	etb.destroy();
	updateProgramNode(mux_key,prog_key);
	$('.theme-popover-mask').fadeOut(100);
	$('#theme_popover_edit_prog').slideUp(200);
}

function addTableRow(type,pid,mux_pid,passFlag)
{
	var etbRow;
	etbRow = addEditorTableRow(etb);

	etbRow.setCellData(0, type);
	etbRow.setCellData(1, pid);
	etbRow.setCellData(2, mux_pid);
	etbRow.setCellData(3, passFlag);
}

function edit_program_click(mux_index,prog_key)
{
	//console.log(GlobalSpace.Edit_Program_Infos);

	//1.生成table 表头
	$("#edit_mux_ch").html('');
	$("#edit_prog_key").html('');

	$("#edit_mux_ch").html(parseInt(mux_index));
	$("#edit_prog_key").html(prog_key);

	var cellMod,headstr='';
	var et = document.getElementById("edit_pid_table");

	2.// get JSON 并 赋值 生成 table
	var mux_key = "mux_"+parseInt(mux_index);
	var key_jsonStr;

	if(GlobalSpace.Edit_Program_Infos.value[mux_key])
	{
		key_jsonStr = GlobalSpace.Edit_Program_Infos.value[mux_key][prog_key];
	}
	if(key_jsonStr)
	{
		$("#LcnSwich").val(key_jsonStr.Mux_prog_infos.LcnSwich);
		$("#Lcn_val").val(key_jsonStr.Mux_prog_infos.Lcn_val);
		$("#charset_type").val(key_jsonStr.Mux_prog_infos.C_TYPE);
		$("#service_name").val(key_jsonStr.Mux_prog_infos.prog_name);
		$("#service_provider_name").val(key_jsonStr.Mux_prog_infos.provider_name);
		$("#service_id").val(key_jsonStr.Mux_prog_infos.prog_num);
		$("#pmt_pid").val(key_jsonStr.Mux_prog_infos.PMT_pid);
		$("#pmt_version").val(key_jsonStr.Mux_prog_infos.PMT_version);
		$("#service_type").val(key_jsonStr.Mux_prog_infos.S_TYPE);

		etb = new EditorTable(et);
		//console.log(etb);
		etb.cellModel.push(cellMod = new EditorTableCellModel(EditorTableCell.ORIGINAL));
		etb.cellModel.push(cellMod = new EditorTableCellModel(EditorTableCell.ORIGINAL));
		etb.cellModel.push(cellMod = new EditorTableCellModel(EditorTableCell.TEXT));//input
		cellMod.style = "text-align:center;";
		cellMod.setAttr("size", 10);
		cellMod.setAttr("maxLength", 4);

		etb.cellModel.push(cellMod = new EditorTableCellModel(EditorTableCell.CHECKBOX));//CHECKBOX


		addTableRow("PCR PID",key_jsonStr.Original_prog_infos.PCR_pid,key_jsonStr.Mux_prog_infos.PCR_pid,key_jsonStr.Mux_prog_infos.PCR_pass);

		var location;
		for(var i=0;i<key_jsonStr.Mux_pid_infos.length;i++)
		{
			location=0;
			type=0;
			location = parseInt(key_jsonStr.Mux_pid_infos[i].type)*2 ; //0x02 的 位置
			if(parseInt(key_jsonStr.Mux_pid_infos[i].type) != 0 && parseInt(key_jsonStr.Mux_pid_infos[i].type) == parseInt(pidsType[location]) && pidsType[location + 1] != "Reserved")
			{
				addTableRow(pidsType[location + 1],key_jsonStr.Mux_pid_infos[i].pid,key_jsonStr.Mux_pid_infos[i].mux_pid,key_jsonStr.Mux_pid_infos[i].pass);
			}
			else
			{
				addTableRow(key_jsonStr.Mux_pid_infos[i].type,key_jsonStr.Mux_pid_infos[i].pid,key_jsonStr.Mux_pid_infos[i].mux_pid,key_jsonStr.Mux_pid_infos[i].pass);
			}
		}
		for(var i=0;i<key_jsonStr.Ecmpids_Num.length;i++)
		{
			addTableRow("ECM",key_jsonStr.Ecmpids_Num[i].pid,key_jsonStr.Ecmpids_Num[i].mux_pid,key_jsonStr.Ecmpids_Num[i].pass);
		}
		//3.打开
		$('.theme-popover-mask').fadeIn(100);
		$('#theme_popover_edit_prog').slideDown(200);
	}
	else
	{
		alert("The program data anomalies !");
	}
}

/*  2015/09/17
 * 设置 显示 不显示 图标. 什么条件显示 /不显示
 */
function showIconForTree(treeId, treeNode) {
	return true;
};
/* **** lxzheng 2016/02/25 *** */
function initValidformAlarm()
{
	var G=GlobalSpace,
		i=0;

	G.mux_ch_set_alarm=$(".theme-signin").Validform({
		tiptype:$.pbi_VFtiptypefn,
		tipSweep:false,
		showAllError:true,
	}).addRule([
		{
			ele:"#outbit",
			datatype:"mux_bitrate",
			nullmsg:"Out Bitrate is null!",
			errormsg:"Out Bitrate is between 0 and 100000!"
		},
		{
			ele:"#chname",
			datatype:"muxname",
			errormsg:"Channel Name is error!"
		},
		{
			ele:"#tsid",
			datatype:"BYTE2",
			nullmsg:"TS ID is null!",
			errormsg:"TS ID is between 0 and 65535!"
		},
		{
			ele:"#onid",
			datatype:"BYTE2",
			nullmsg:"Original ID is null!",
			errormsg:"Original ID is between 0 and 65535!"
		},
		{
			ele:"#PATTrans",
			datatype:"pat",
			nullmsg:"Period of PAT Transmiting  is null!",
			errormsg:"Period of PAT Transmiting is between 25 and 500!"
		},
		{
			ele:"#PMTTrans",
			datatype:"pat",
			nullmsg:"Period of PMT Transmiting  is null!",
			errormsg:"Period of PMT Transmiting  is between 25 and 500!"
		},
		{
			ele:"#SDTTrans",
			datatype:"sdt",
			nullmsg:"Period of SDT Transmiting  is null!",
			errormsg:"Period of SDT Transmiting is between 25 and 2000!"
		},
		{
			ele:"#CATTrans",
			datatype:"pat",
			nullmsg:"Period of CAT Transmiting  is null!",
			errormsg:"Period of CAT Transmiting is between 25 and 500!"
		}
	]);

}
/*
 *1.提交源后 将的到的 节目信息 添加到 各个属于自己的节点中.
 *2.将 有节目的 源展开.其他的依旧关闭.
 */
function onTimer_Refresh_pro_list_success(para)
{
	//console.log(para);
	var P=para,
		G=GlobalSpace,
		in_para={},
		addNodes=[],
		p_para={},
		mux_para={},
		tree_items_index=0,
		temp_obj={},
		prog_obj={},
		temp_obj_p={},//program
		temp_obj_i={},//item
		tree_node=[],
		temp_es_pids=[],
		temp_ecm_pids=[],
		temp_emm_pids=[],
		temp_num=0,
		temp_id="",
		temp_pid="",
		temp_name="",
		num_head="",
		mux_item=[],
		mux_pro=[],
		mux_pro_inch=0,
		mux_pro_pn=0,
		mux_pro_sou=[],
		mux_pro_t="",
		index_tree = 0;
	if(isDefined(P.REMUX_JSON_DATA) && P.REMUX_JSON_DATA.items_qty != undefined && P.REMUX_JSON_DATA.items_qty > 0 ){
		source_setting={
			treeId:"s",
			view:{
				nameIsHTML: true,
				showIcon: showIconForTree,
				showTitle: false

			},
			edit: {
				enable: true,
				showRemoveBtn: false,
				showRenameBtn: false,
				drag:{
					maxShowNodeNum:20,
					isCopy:true,
					isMove:false,
					prev:false,
					next:false,
					inner:false
				}
			},
			data: {
				key: {
					title:"t"
				},
				simpleData: {enable: true}
			},
			callback: {
				beforeDrag: source_beforeDrag,
				onDrag:false,
				beforeDrop: source_beforeDrop,
				onDrop: source_onDrop,
				beforeCheck: source_beforeCheck,
				onCheck:source_onCheck,
				onRightClick:source_OnRightClick
			},
			check:{
				enable:true,
				nocheckInherit: true,
				chkboxType: { "Y": "ps", "N": "ps" }

			}
		};

		mux_setting={
			treeId:"m",
			view:{
				nameIsHTML: true,
				addDiyDom: mux_addDiyDom,
				//addHoverDom: addHoverDom,
				//removeHoverDom: removeHoverDom,
				showTitle: false,
				fontCss:setFontCss
			},
			edit: {
				enable: true,
				editNameSelectAll: true,
				showRemoveBtn: mux_showRemoveBtn,
				showRenameBtn: mux_showRenameBtn,
				//showRenameBtn: false,
				drag:{
					isCopy:false,
					isMove:false,
					prev:true,
					next:true,
					inner:true
				}
			},
			data: {
				key: {
					title:"t"
				},
				simpleData: {enable: true}
			},
			callback: {
				beforeDrag: false,
				onDrag:true,
				beforeDrop: false,
				onRemove:mux_remove, //删除节点的回调
				beforeCheck: mux_beforeCheck,
				onCheck:mux_onCheck,
				onRightClick:mux_OnRightClick,
				beforeEditName: beforeEditName,
				beforeRename: beforeRename,
				onRename: onRename
			},
			check: {
				enable:true,
				nocheckInherit: true,
				chkboxType: { "Y": "ps", "N": "ps" }
			}
		};

		/* lxzheng 2016/03/21 Remux Basic Infos  */
		if(typeof(P.REMUX_BASIC_INFO) != undefined)
		{
			$.getBasicInfos(G.Remux_BasicInfos_Value,P.REMUX_BASIC_INFO.value);
		}else{
			G.Remux_BasicInfos_Value.mux_total = 16;
		}
		/* End Remux Basic Infos  */


		/**********  Gen Mux Tree **********/

		//生成 父亲节点
		G.muxNodes =[
			{ id:1, pId:0, name:"Mux", open:true,t:"Mux",checked:false, halfCheck:false}
		];

		for(i=0; i<G.Remux_BasicInfos_Value.mux_total; i++){
			G.muxNodes[i+1] = {};
			temp_obj_p = G.muxNodes[i+1];
			temp_obj_p.id = "m";
			temp_obj_p.id += G.muxNodes[0].id;
			temp_obj_p.id += i;
			temp_obj_p.pId=G.muxNodes[0].id;
			temp_obj_p.name='m' + (i+1);
			temp_obj_p.t = temp_obj_p.name;
			temp_obj_p.iconSkin="pTs";
		}

		var system = $.getConvertNum(G.Remux_BasicInfos_Value.ary_sw);

		/********** Gen Input Tree Nodes**********/
		if(P.INPUT_TREE)
		{
			$.pbi_GenInTreeProNodes(P,system);
		}

		/**********End Gen Input Tree Nodes**********/


		if(para){
			mux_para.INPUT_TREE = P.INPUT_TREE;
			mux_para.Edit_Program_Infos = P.Edit_Program_Infos;
			mux_para.MUX_SET_INFOS = P.MUX_SET_INFOS;
			mux_para.Mux_Refresh_Infos = P.Mux_Refresh_Infos;
			mux_para.tree_open=1;
			mux_para.bitrate_ena=0;

			$.pbi_GenMainBoardMuxTree(mux_para,system); //节点
		}


		/**********  End Gen Mux Tree Nodes **********/


		/************int Intree && MuxTree *****************/

		$.fn.zTree.init($("#t_source"), source_setting, G.socNodes);
		source_treeObj = $.fn.zTree.getZTreeObj("t_source");
		src_Menu = $("#src_Menu");

		var checknodes = source_treeObj.getCheckedNodes(true);
		for(var temp=0;temp<checknodes.length;temp++)
		{
			source_treeObj.expandNode(checknodes[temp], true, false, true);
		}

		$.fn.zTree.init($("#t_mux"), mux_setting, G.muxNodes);
		mux_treeObj = $.fn.zTree.getZTreeObj("t_mux");
		//console.log("mux_treeObj="+mux_treeObj);
		rMenu = $("#rMenu");
		rPidMenu = $("#rPidMenu");

//	console.log(G.max_prog_key);
		/**********************End  int tree **********************/
	}else{
		console.log("No Items");
		setTimeout(refresh_pro_list, 1000);
	}

}

//==========================
function onTimer_Refresh_pro_list_error(para) {
	alert("mux page request error : "+para);
	setTimeout(refresh_pro_list, 5000);
}

function refresh_pro_list()
{
	var G=GlobalSpace,
		jsonStr='';
	if(G.json_debug == 1)
	{
		G.dataurl = "MUX_tree.json";
	}

//	ajax_para.url=G.dataurl + '?id='+GlobalSpace.page_id;
	G.def_ajax_para.url = G.dataurl + '?id='+GlobalSpace.page_id;
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:G.def_ajax_para.url,
		async:true,
		data:{json:''},
		success: function(data){
			onTimer_Refresh_pro_list_success(data);
			mybusy.remove();
		},
		error: function(xhr, status){
			//alert('Data are wrong please modify !');
			onTimer_Refresh_pro_list_error(status);
			mybusy.remove();
		}
		/*		complete : function(xhr,status){ //请求完成后最终执行参数
		 alert(status);
		 if(status=='timeout'){//超时,status还有success,error等值的情况
		 //ajaxTimeoutTest.abort();
		 //alert("超时");
		 }
		 }*/
	});
	// $.pbi_ajaxWrap_mainmux(jsonStr, G.def_ajax_para, onTimer_Refresh_pro_list_success, onTimer_Refresh_pro_list_error);
}



function onInitReceived(para)
{
	var P=para,
		G=GlobalSpace,
		in_para={},
		spro_name = '',
		spro_ch = 0,
		spro_PN = 0,
		spro_arr=[],
		socNodes=[],
		muxNodes=[],
		tree_items_index=0,
		temp_obj={},
		temp_obj_p={},//program
		temp_obj_i={},//item
		temp_vlaue=[],
		temp_es=[],
		temp_num=0,
		temp_id="",
		temp_pid="",
		temp_name="",
		num_head="",
		mux_item=[],
		mux_pro=[],
		mux_pro_inch=0,
		mux_pro_pn=0,
		mux_pro_sou=[],
		mux_pro_t="",
		i = 0,
		j = 0,
		k = 0,
		h = 0;


	if(!(P.SET_TRANS))
	{
		alert("Init src parameter is NULL !");
		return 1;
	}

	$('#theme_popover_muxset .close').on({
		click:function (){
			$('.theme-popover-mask').fadeOut(100);
			$('#theme_popover_muxset').slideUp(200);
		}
	});

	$('#theme_popover_edit_prog .close').on({
		click:function (){
			etb.destroy();
			$('.theme-popover-mask').fadeOut(100);
			$('#theme_popover_edit_prog').slideUp(200);
		}
	});

	$('#filter_button').on({
		click:function (){filter_button_apply(0);}
	});

	$('#edit_program_ok').on({
		click:function (){edit_program_ok_click();}
	});

	/***************Init input tree*******************/
	if (P.SET_TRANS){
		in_para.SET_TRANS=P.SET_TRANS;
		in_para.tree_open=0;
		in_para.bitrate_ena=0;

		G.socNodes = $.pbi_GenInSource(in_para,G,7);
	}

	refresh_pro_list(); //inTree && MuxTree

	/* ***lxzheng 2016/02/25 ****/

	$.pbi_ValidformInit();
	initValidformAlarm();

	/* ***End lxzheng 2016/02/25 ****/

}