﻿(function ($) {
    //初始化load
    $.ajaxProc = function(actType){
   //     console.log(actType);
        $.loadData(actType);
    };
    $.loadData = function(actType){
   //     console.log(actType);
        var loadObj = $(window.top.document.getElementsByClassName("loading-container"));
   //     console.log(loadObj);

        switch(parseInt(actType)){
            case $.DEF.AJAX_ACT_TYPE.LOAD:
                if(!loadObj.hasClass("active")){
                    loadObj.addClass("active");
                }
                break;
            case $.DEF.AJAX_ACT_TYPE.REMOVE:
                if(loadObj.hasClass("active")){
                    loadObj.removeClass("active");
                }
                break;
            default:
                if(loadObj.hasClass("active")){
                    loadObj.removeClass("active");
                }
                break;
        }
    };
    $.DEF= {
        AJAX_ACT_TYPE: {
            DEFAULT: 0,
            LOAD: 1,
            REMOVE: 255
        },
        SEND_TYPE: {
            GIVE: 0,
            GET: 1
        }
    };
    $.fnDefine={};
    $.onReceivedError = function (para,errMsg,isHint) {
        //console.log(para);
        for(var key in para){
            if(para.hasOwnProperty(key)) {
                if (!$.fnDefine[key] || !$.fnDefine[key].data)
                    continue;
                $.fnDefine[key].data = para[key] ? para[key] : null;
                if (!$.fnDefine[key].error)
                    continue;
                $.fnDefine[key].error($.fnDefine[key].data,errMsg,isHint);
            }
        }
    };
    $.onReceivedSucess =  function (para,isHint) {
      // console.log(para);
        for(var key in para){
            if(para.hasOwnProperty(key)) {
               // console.log(key);
                if (!$.fnDefine[key] || !$.fnDefine[key].data)
                    continue;
                $.fnDefine[key].data = para[key] ? para[key] : null;

                if (!$.fnDefine[key].sucess)
                    continue;
                $.fnDefine[key].sucess($.fnDefine[key].data,isHint);
            }
        }
    };

    $.invokeRequest = function (ajaxParam) {
        $.ajax({
            dataType: isDefined(ajaxParam.dataType)?ajaxParam.dataType:"json",
            type: isDefined(ajaxParam.type)?ajaxParam.type:"POST",
            url: isDefined(ajaxParam.url)?ajaxParam.url:"",
            async: isDefined(ajaxParam.async)?ajaxParam.async:true,
            timeout: isDefined(ajaxParam.timeout)?ajaxParam.timeout:20000,
            data:{json:isDefined(ajaxParam.data)?ajaxParam.data:""},
            cache:isDefined(ajaxParam.cache)?ajaxParam.cache:true,
            beforeSend:function(XMLHttpRequest){
                if(ajaxParam.actBeforeFun){
                    ajaxParam.actBeforeFun(ajaxParam.actBeforeType);
                }

                //可修改 XMLHttpRequest 对象的函数，如添加自定义 HTTP 头
            },
            success:function(data){
                $.onReceivedSucess(data,ajaxParam.isHint);
                setTimeout(function () {
                    if(ajaxParam.actEndFun){
                        ajaxParam.actEndFun(ajaxParam.actEndType);
                    }
                },500);
            },
            dataFilter : function(data, type){
                if(data == "timeOut" || data == "[object XMLDocument]"){
                    console.log("ajax请求，发现session过期，重新刷新页面，跳转到登录页面");
                    top.location.href = "../../login.html";//   window.location.reload();
                }else{
                    return data; //必须return
                }
            },
            error:function(xhr,errMsg,catchObj){
                console.log("Ajax errMsg:"+errMsg);
//              if(xhr.status===0&&xhr.readyState===0&&errMsg=="error"&&(!catchObj)){
                	//表示重启，什么都不用做
//              }else if(xhr.status===0&&xhr.readyState===0&&errMsg=="timeout"&&catchObj){
                	//表示重启之后用户长时间不点击跳转，容错处理
//              	setTimeout(function(){
//              		top.location.reload()
//              	},100)
//              }else{
                	$.onReceivedError(JSON.parse(ajaxParam.data),errMsg,1);
                	setTimeout(function () {
	                    if(ajaxParam.actEndFun){
	                        ajaxParam.actEndFun(ajaxParam.actEndType);
	                    }
                	},500);
//              }
            }
        });
    };

})(jQuery);

function UserFormData() {
    this.method = (arguments.length>0 && arguments[0])?arguments[0]:0;
    this.data = (arguments.length>1 && arguments[1])?arguments[1]:{};
}
UserFormData.add = function(dataObj,key) {
    var func = new UserFormData(arguments[2],arguments[3]);
    dataObj[key] = func;
};

function FnDefine() {
	//console.log("11arguments[0]="+arguments[0]);
	//console.log("11arguments[1]="+arguments[1]);
	//console.log("11arguments[2]="+arguments[2]);
    this.sucess = (arguments.length>0 && arguments[0])?arguments[0]:{};
    this.error = (arguments.length>1 && arguments[1])?arguments[1]:{};
    this.data = (arguments.length>2 && arguments[2])?arguments[2]:{};
}

FnDefine.add = function(key) {
	//console.log("key="+key);
	//console.log("arguments[0]="+arguments[0]);//128
	//console.log("arguments[1]="+arguments[1]);
	//console.log("arguments[2]="+arguments[2]);
	//console.log("arguments[3]="+arguments[3]);
    var func = new FnDefine(arguments[1],arguments[2],arguments[3]);
    $.fnDefine[key] = func;
};

function UserAjaxParam() {
    this.dataType =  "json";
    this.type =  'POST';
    this.url = "";
    this.async = true;
    this.timeout = 40000;
    this.data = "";
    this.cache = true  ;// true，dataType 为 script 和 jsonp 时默认为 false。设置为 false 将不缓存此页面。

    this.actBeforeType = $.DEF.AJAX_ACT_TYPE.LOAD;
    this.actBeforeFun = $.ajaxProc;

    this.actEndType = $.DEF.AJAX_ACT_TYPE.REMOVE;
    this.isModal = 1; //1模态 0 非模
    this.isDataFront = 0 ;//1 在获取数据前移除，0在获取数据后移除
    this.actEndFun = $.ajaxProc;
    this.isHint = 0;
}
UserAjaxParam.prototype.update = UserAjaxParam.prototype.update || function (para) {
    for(var key in para){
        if(para.hasOwnProperty(key)){
            this[key] = para[key];
        }
    }
};
//提示插件的植入
function applyHintSucess(){
    hint.success("Parameters are set successfully!");
}
function applyHintError(errMsg){
    hint.error(errMsg);
}